﻿using System;
using System.Data;
using SQLDatabase.Net.SQLDatabaseClient;

namespace SQLDabase.Net.Mono.Sample
{
	class MainClass
	{
		public static void Main (string[] args)
		{
			using (SqlDatabaseConnection cnn = new SqlDatabaseConnection ("uri=file://@memory")) {
				cnn.Open ();
				if (cnn.State == ConnectionState.Open) {
					using (SqlDatabaseCommand cmd = new SqlDatabaseCommand ()) {
						cmd.Connection = cnn;
						cmd.CommandText = "SYSCMD journal_mode = MEMORY;";
						cmd.ExecuteNonQuery();
						cmd.CommandText = "DROP TABLE IF EXISTS TEST_TABLE;";
						cmd.ExecuteNonQuery();
						cmd.CommandText = "CREATE TABLE IF NOT EXISTS TEST_TABLE ( Id INTEGER PRIMARY KEY ASC AUTOINCREMENT, COLA INTEGER, [COLB] TEXT, COLC DATETIME ) ;";
						cmd.ExecuteNonQuery();
						System.Diagnostics.Stopwatch watch = System.Diagnostics.Stopwatch.StartNew();
						for (int i = 0; i < 100; i++)
						{
							cmd.CommandText = "INSERT INTO TEST_TABLE ( Id, COLA, COLB, COLC ) VALUES (null, " + i + ", trim(rtrim(' ABCD ')),'2014-12-31 15:16:17' );";
							cmd.ExecuteNonQuery();
						}
						watch.Stop();
						Console.WriteLine("Insert Successful in : " + watch.Elapsed.TotalMilliseconds);
						cmd.CommandText = "SELECT last_insert_rowid() as last_insert_rowid;";
						Console.WriteLine("Last Id: {0} " , cmd.ExecuteScalar().ToString());
						cmd.CommandText = "SELECT Id FROM TEST_TABLE LIMIT 4 OFFSET 10 ; ";
						SqlDatabaseDataReader dr = cmd.ExecuteReader ();

						while (dr.Read ()) {
							if (!dr.HasRows) {
								break;
							}
							for(int i = 0 ; i < dr.FieldCount ; i++) {
								Console.WriteLine(dr.GetString(i));
							}
						}
						if (dr.HasRows) {
							Console.WriteLine ("Records Found!");
						}
						cmd.CommandText = "CREATE TABLE TEST_RefTable ( COL_Id INTEGER PRIMARY KEY ASC, COLA INTEGER, DummyCOL TEXT, FOREIGN KEY(COLA) REFERENCES TEST_TABLE(COLA) );";
						cmd.ExecuteNonQuery();

						Console.WriteLine ("");
						Console.WriteLine ("Deleting Records...");
						cmd.CommandText = "DELETE FROM TEST_TABLE;";
						cmd.ExecuteNonQuery();
						cmd.CommandText = "SELECT Id FROM TEST_TABLE LIMIT 4 OFFSET 10 ; ";
						dr = cmd.ExecuteReader ();

						while (dr.Read ()) {							
							for(int i = 0 ; i < dr.FieldCount ; i++) {
								Console.WriteLine(dr.GetValue(i));
							}
						}
						if (!dr.HasRows) {
							Console.WriteLine ("Records deleted successfully.");
						}
						dr.Close ();

						cmd.CommandText = "VACUUM TEST_TABLE;";
						cmd.ExecuteNonQuery();
						cmd.CommandText = "SYSCMD INTEGRITY_CHECK;";
						Console.WriteLine ("Integrity Check: {0} ", cmd.ExecuteScalar().ToString());

					}
				}
				if (cnn.State == ConnectionState.Open)
					cnn.Close ();
			}
			Console.WriteLine ("Done... Press any key to exit.");
			Console.ReadKey ();
			Environment.Exit (0);
		}
	}
}
